11. Container With Most Water 盛最多水的容器 # Two-pointers

11. Container With Most Water

https://leetcode.com/problems/container-with-most-water/

Description

Given n non-negative integers a1, a2, …, an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2.

The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.

Example:

Input: [1,8,6,2,5,4,8,3,7]
Output: 49

Solutions

  1. 结果很好表示,就是索引的差和索引对应的值的差的乘积。brute force遍历的时间复杂度是O(n^2),只遍历一遍可以用双指针。
  2. 那么双指针怎么移动呢?
    在这个模型中,起始点取最左left和最右right,(right-left)的值是最大的,随着指针向里移动,(right-left)的值会越来越小,所以竖着的值即height[left]和height[right]要越来越大才行 (不是这样想的,这太严格了。)
    所以要向好的方向移动,好的方向就是左右指针的下一位哪个大,就往哪个方向动。

Submissions

class Solution {
    public int maxArea(int[] height) {
        int len=height.length;
        int left=0;
        int right=len-1;
        int area=0;
        while(left<right)
        {
            area=Math.max(area,(right-left)*Math.min(height[left], height[right]));
            //重点是指针怎么移动:
            if (height[left] < height[right]) // 贪心
                left++;
            else
                right--;
        }
        return area;
    }
}

Summary

贪心算法比动态规划简单多惹~
我一开始想的比较是分别比较height[left]和height[left+1]、height[right]和height[right-1],然后就迷茫了,不知道该选谁,这种比较一组合就变成了很多种结果……不好写。也确定不了只移动一个指针还是移动两个指针,如果都是小于,那怎么移?问题越想越复杂就想不出来了。
确定每次只移动一个指针就会很好比较。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值